//PARTIKEL.WDL////////////
//CREATED 17.3.2002///////
// by Alok-Productions///
path "..\\gfx\\part";
path "..\\gfx\\other";


//BMAPS
bmap explo_1  = <explo_1.pcx>;
bmap blue_1   =  <blue_1.pcx>;
bmap blue_2   =  <blue_2.pcx>;
bmap blue_3   =  <blue_3.pcx>;
bmap red_1    =   <red_1.pcx>;
bmap green_1  = <green_1.pcx>;
bmap gelb_1   =  <gelb_1.pcx>;
bmap smoke_1  = <smoke_2.pcx>;


//SYNONYMS
synonym exring { type entity; } 

function r_function();

function e_rocket() {
	my.vel_x=(random(10)-5);
	my.vel_y=(random(10)-5);
	my.vel_z=2*time;
	my.move=on;
	my.size=30;
	my.bmap= explo_1;
	my.flare = on;
	my.bright = on;	
	my.function=r_function;
	my.transparent = on;
  my.alpha = 30;
  my.lifespan =20;
}


function r_function()
{
  if(my.lifespan > 9)
  {
   my.size += 5 *time;
  }
  if(my.lifespan <=8)
  {
   my.size  -=2*time;
   my.alpha -=5*time;
  }
	
	
	if (my.alpha<=0) {
		my.lifespan=0;
	}
}

function p_rocket() {
		temp.x = my.x;
		temp.y = my.y;
		temp.z = my.z;
		effect(e_rocket,100*time,temp,temp);
		ent_create (exploring,my.pos,druckwelle);		
return;
}



function druckwelle()
{
 my.passable = on;
 my.scale_x = 0.1;
 my.scale_y = 0.1; 
 my.flare = on;
 my.bright = on;
 my.transparent = on;
 
 my.facing = off;
 my.oriented = on;
 my.tilt = 270;
 while(my.scale_x <= 2)
 {
  my.scale_x += 0.1*time;
  my.scale_y += 0.1*time;
  wait(1);
 }
 if(my.scale_x >= 2)
 { ent_remove(me);}
}



function rocketl()
{
 p_rocket();
 return;
}


function star_effect();
function star_effect_f();
function star_effect_emitter();

function star_effect() {
	my.vel_x=random(1)-0.5;
	my.vel_y=random(1)-0.5;
	my.vel_z=random(1)-0.5;
	my.move=on;
	my.size=10;
	my.bmap= red_1;
	my.flare = on;
	my.bright = on;	
	my.function=star_effect_f;
	my.transparent = on;
  my.alpha = 30;
  my.lifespan =10;
}

function star_effect_f()
{
  if(my.lifespan <=8)
  {
   my.alpha -=5*time;
  }
	if (my.alpha<=0) 
	{
		my.lifespan=0;
	}
}

function star_effect_emitter() 
{
		temp.x = my.x;
		temp.y = my.y;
		temp.z = my.z;
		effect(star_effect,50*time,temp,temp);
}

function heart_effect();
function heart_effect_f();
function heart_effect_emitter();

function heart_effect() {
	my.vel_x=random(5)-2.5;
	my.vel_y=random(5)-2.5;
	my.vel_z=random(5)-2.5;
	my.move=on;
	my.size=10;
	my.gravity = 1;
	my.bmap= red_1;
	my.flare = on;
	my.bright = on;	
	my.function=star_effect_f;
	my.transparent = on;
  my.alpha = 30;
  my.lifespan =100;
}

function heart_effect_f()
{
  if(my.lifespan <=8)
  {
   my.alpha -=5*time;
  }
	if (my.alpha<=0) 
	{
		my.lifespan=0;
	}
}

function heart_effect_emitter() 
{
		temp.x = my.x;
		temp.y = my.y;
		temp.z = my.z;
		effect(heart_effect,50*time,temp,temp);
}


function speed_effect_p();
function speed_effect_f();
function speed_effect_emitter();

function speed_effect_p() 
{
	my.vel_x=random(3)-1.5;
	my.vel_y=random(3)-1.5;
	my.vel_z=random(3)-1.5;
	my.move=on;
	my.size=60;
	my.bmap= explo_1;
	my.flare = on;
	my.bright = on;	
	my.function=star_effect_f;
	my.transparent = on;
  my.alpha = random(50);
  my.lifespan =40;
}

function speed_effect_f()
{
  if(my.lifespan <=8)
  {
   my.alpha -=5*time;
   my.size -= 2*time;
  }
	if (my.alpha<=0) 
	{
		my.lifespan=0;
	}
}

function speed_effect_emitter() 
{
		temp.x = you.x;
		temp.y = you.y;
		temp.z = you.z;
		effect(speed_effect_p,3*time,temp,temp);
}

function gsmoke_effect_p();
function gsmoke_effect_f();

function gsmoke_effect_p() 
{
	my.vel_x=random(1)-0.5;
	my.vel_y=random(1)-0.5;
	my.vel_z=random(3);
	my.move=on;
	my.size=10;
	my.bmap= smoke_1;
	my.flare = on;
	my.bright = on;	
	my.function=gsmoke_effect_f;
	my.transparent = on;
  my.alpha = 30;
  my.lifespan =15;
}

function gsmoke_effect_f()
{
  if(my.lifespan <=8)
  {
   my.alpha -=5*time;
  }
	if (my.alpha<=0) 
	{
		my.lifespan=0;
	}
}

function rsmoke_effect_p();
function rsmoke_effect_f();

function rsmoke_effect_p() 
{
	my.vel_x=random(1)-0.5;
	my.vel_y=random(1)-0.5;
	my.vel_z=random(3);
	my.move=on;
	my.size=30;
	my.bmap= smoke_1;
	my.flare = on;
	my.bright = on;	
	my.function=rsmoke_effect_f;
	my.transparent = on;
  my.alpha = 30;
  my.lifespan =15;
}

function rsmoke_effect_f()
{
  if(my.lifespan <=8)
  {
   my.alpha -=5*time;
  }
	if (my.alpha<=0) 
	{
		my.lifespan=0;
	}
}


function nokill_part_f();

function nokill_part() {
	my.vel_x= random(5)-2.5;
	my.vel_y= random(5)-2.5;
	my.vel_z= 1*time;
	my.move=on;
	my.size=10;
	my.bmap= explo_1;
	my.flare = on;
	my.bright = on;	
	my.function=nokill_part_f;
	my.transparent = on;
  my.alpha = 30;
  my.lifespan =10;
}


function nokill_part_f()
{

  if(my.lifespan <=8)
  {
   my.size  -=2*time;
   my.alpha -=5*time;
   }

}

function emit_nokill() {
		temp.x = you.x;
		temp.y = you.y;
		temp.z = you.z;
		effect(nokill_part,20*time,temp,temp);	
}

function pfire_effect_f();

function pfire_effect_p() 
{
	my.vel_x=random(2)-1;
	my.vel_y=random(2)-1;
	my.vel_z=random(4);
	my.move=on;
	my.size=25;
	my.bmap= explo_1;
	my.flare = on;
	my.bright = on;	
	my.function= pfire_effect_f;
	my.transparent = on; 
	my.alpha = random(40);
  my.lifespan =20;
}

function pfire_effect_psm() 
{
	my.vel_x=random(2)-1;
	my.vel_y=random(2)-1;
	my.vel_z=random(4);
	my.move=on;
	my.size=random(5);
	my.bmap= explo_1;
	my.flare = on;
	my.bright = on;	
	my.function= pfire_effect_f;
	my.transparent = on; 
	my.alpha = random(40);
  my.lifespan =random(35);
}

function pfire_effect_f()
{
  if(my.lifespan <=10)
  {
   my.alpha -=5*time;
   my.size -= 1*time;
  }
	if (my.alpha<=0) 
	{
		my.lifespan=0;
	}
}

var palm_rnd;
entity* p_fire_pos;
function pfire_effect_emitter_e(vertex)
{
  ent_vertex(temp,vertex);
  effect(pfire_effect_p,3*time,temp,temp);
  effect(pfire_effect_psm,3*time,temp,temp);
}


  



